﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.Threading;
using System.IO;

namespace WeightSensor
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        //12,6 points on kilo
        Thread t = null;
        private void Form1_Load(object sender, EventArgs e)
        {
            string[] theSerialPortNames = System.IO.Ports.SerialPort.GetPortNames();
            
            foreach (var port in theSerialPortNames)
            {
                listBox1.Items.Add(port);
            }
            t = new Thread(new ThreadStart(inv));
            t.Start();
        }
        public void inv()
        {
            while (true)
            {
                Invalidate();
                Thread.Sleep(20);
            }
        }
        SerialPort mySerialPort = null;
        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            //mySerialPort = new SerialPort((string)listBox1.SelectedItem);
            mySerialPort = new SerialPort("COM16");

            mySerialPort.BaudRate = 9600;
            mySerialPort.Parity = Parity.None;
            mySerialPort.StopBits = StopBits.One;
            mySerialPort.DataBits = 8;
            mySerialPort.Handshake = Handshake.None;

            mySerialPort.DataReceived += new SerialDataReceivedEventHandler(DataReceivedHandler);

            mySerialPort.Open();

            //tx.Text += "port " + (string)listBox1.SelectedItem + " opened\r\n";
        }
        static List<float> vals = new List<float>();
        static List<int> gercon = new List<int>();
        static List<double> total_milliseconds = new List<double>();
        static DateTime start = DateTime.Now;
        private static void DataReceivedHandler(object sender, SerialDataReceivedEventArgs e)
        {
            SerialPort sp = (SerialPort)sender;
            
            try
            {
                string val = sp.ReadLine();
                string v = val.Replace("\n", "");
                v = val.Replace("\r", "");
                v = val.Replace(".", ",");
                float vv = 0;
                float.TryParse(v, out vv);
                vals.Add(vv);

                total_milliseconds.Add(((TimeSpan)(DateTime.Now - start)).TotalMilliseconds);

                val = sp.ReadLine();
                int gercon_now = int.Parse(val);
                bool found_gercon = false;
                if (gercon.Count > 15)
                {
                    for (int i = gercon.Count - 15; i < gercon.Count; i++)
                    {
                        if (gercon[i] == 1)
                        {
                            found_gercon = true;
                            break;
                        }
                    }
                }
                if (gercon_now == 0)
                {
                    if(found_gercon)
                    gercon.Add(0);
                    else
                        gercon.Add(1);
                }
                else
                {
                    gercon.Add(0);
                }
            }
            catch
            {
            }
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            try
            {
                var last_n = vals.Skip(Math.Max(0, vals.Count() - Width)).ToArray();
                var last_n_time = total_milliseconds.Skip(Math.Max(0, total_milliseconds.Count() - Width)).ToArray();
                var last_n_gercon = gercon.Skip(Math.Max(0, gercon.Count() - Width)).ToArray();



                for (int i = 1; i < last_n.Length; i++)
                {
                    if (last_n_gercon[i] == 1)
                    {
                        e.Graphics.DrawLine(Pens.Black, i, 0, i, Height);
                    }
                }
                e.Graphics.DrawLine(Pens.Green, 0, 500, Width, 500);

                double[] avg = new double[last_n.Length];
                for (int i = 0; i < last_n.Length; i++)
                {
                    avg[i] =GetMedian( last_n.Skip(Math.Max(0, i)).Take(3).Select(x=>(double)x).ToArray());
                }

                var intervals = calcIntervals(last_n_gercon);
                intervalCountLabel.Text = intervals.Count.ToString();

                double total_kilos = 0;
                int total_counts = 0;
                if (intervals.Count > 5)
                {
                    for (int inn = intervals.Count - 5; inn < intervals.Count; inn++)
                    {
                        int steps_of_circle = intervals[inn].p2 - intervals[inn].p1;
                        for (int i = 0; i < steps_of_circle - 1; i++)
                        {
                            //if (inn > intervals.Count - 5)
                            //{
                            total_kilos += avg[i + intervals[inn].p1] / 12.6;
                            total_counts++;
                            //}
                            //x = r cos fi
                            //y = r sin fi
                            double x = avg[i + intervals[inn].p1] / 2 * Math.Cos(2.0 * Math.PI / steps_of_circle * i);
                            double y = avg[i + intervals[inn].p1] / 2 * Math.Sin(2.0 * Math.PI / steps_of_circle * i);

                            double x1 = avg[i + intervals[inn].p1 + 1] / 2 * Math.Cos(2.0 * Math.PI / steps_of_circle * (i + 1));
                            double y1 = avg[i + intervals[inn].p1 + 1] / 2 * Math.Sin(2.0 * Math.PI / steps_of_circle * (i + 1));

                            Pen p = Pens.Green;
                            if (avg[i + intervals[inn].p1] < 0 || avg[i + intervals[inn].p1 + 1] < 0)
                                p = Pens.Red;
                            e.Graphics.DrawLine(p, (int)x + 400, (int)y + 400, (int)x1 + 400, (int)y1 + 400);
                        }
                    }
                }

                if (total_counts > 0)
                {
                    Text = (total_kilos / total_counts).ToString();

                    var last_n_intervals = intervals.Skip(Math.Max(0, intervals.Count() - 5)).ToList();
                    var avg_mills = (last_n_time[last_n_intervals.Last().p2] - last_n_time[last_n_intervals.First().p1]) / last_n_intervals.Count;

                    kad.Text = (60 * 1000 /avg_mills).ToString();
                    
                    mlL.Text = avg_mills.ToString();
                    countsL.Text = total_counts.ToString();
                    kilosL.Text = (total_kilos / total_counts).ToString();

                    var arg_rotations_in_second = 1000f / avg_mills;
                    var power = 2f * Math.PI * total_kilos / total_counts * 10 * 0.175 * arg_rotations_in_second;
                    power_label.Text = power.ToString();
                }

                for (int i = 1; i < last_n.Length; i++)
                {
                    e.Graphics.DrawLine(Pens.Red, i - 1, (int)avg[i - 1]/3 + 500, i, (int)avg[i]/3 + 500);
                }

                for (int i = 0; i < h.Count; i++)
                {
                    e.Graphics.DrawLine(Pens.HotPink, 0, h[i], Width, h[i]);
                    e.Graphics.DrawString(h[i].ToString(), f, Brushes.Black, 10, h[i] - 20);
                }
            }
            catch
            {
            }
        }

        public List<interval> calcIntervals(int[]data)
        {
            List<interval> intr = new List<interval>();

            interval interval = new interval();
            if (data.Length > 5)
            {
                for (int i = data.Length - 1; i > 0; i--)
                {
                    if (data[i] == 1)
                    {
                        if (interval.p2 == 0)
                        {
                            interval.p2 = i;
                        }
                        else
                        {
                            interval.p1 = i;
                            intr.Add(interval);
                            interval = new interval();
                            interval.p2 = i;
                        }
                    }
                }
            }
            intr.Reverse();
            return intr;
        }
        
        public class interval
        {
            public int p1=0;
            public int p2=0;
        }

        Font f = new Font("system", 12);

        public static double GetMedian(double[] sourceNumbers)
        {
            //Framework 2.0 version of this method. there is an easier way in F4        
            if (sourceNumbers == null || sourceNumbers.Length == 0)
                throw new System.Exception("Median of empty array not defined.");

            //make sure the list is sorted, but use a new array
            double[] sortedPNumbers = (double[])sourceNumbers.Clone();
            Array.Sort(sortedPNumbers);

            //get the median
            int size = sortedPNumbers.Length;
            int mid = size / 2;
            double median = (size % 2 != 0) ? (double)sortedPNumbers[mid] : ((double)sortedPNumbers[mid] + (double)sortedPNumbers[mid - 1]) / 2;
            return median;
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {            try
            {
                mySerialPort.Close();
            }
            catch
            {
            }
            try
            {
                File.WriteAllText(@"D:\training_data1.txt", String.Join(";", vals.Select(x => x.ToString()).ToArray()));
                File.WriteAllText(@"D:\training_data2.txt", String.Join(";", gercon.Select(x => x.ToString()).ToArray()));
            }
            catch
            {
            }
            try
            {   
                t.Abort();
            }
            catch
            {
            }

        }
        List<int> h = new List<int>();
        private void Form1_DoubleClick(object sender, EventArgs e)
        {
            h.Add(((MouseEventArgs)e).Y);
        }

        private void kad_Click(object sender, EventArgs e)
        {

        }
    }
}
